//CLab version: Julia Grishina
//Date        : November 2005
type
 Four [0..3];
 Three [0..2];
 Six [0..5];
 Five [0..4];
 FivtyOne [0..50];
 Nine [0..8];
 
variable
 bool Control_type;
 bool Supply_frequency;
 bool Control_voltage;
 bool Week_timer;
 bool Communication_bus_RS485;
 bool Canopy_filter;
 bool Integrated_refridgeration_air_dryer;
 bool Oil_water_separator;
 bool Altitude;
 bool Cooling;
 
 Three  Nominal_power;
 Four Supply_voltage;
 Five Pressure;
 FivtyOne Maximum_capacity;
 Nine Document_language;
 Three Water_draining_system;
 Three Maximum_ambient_temperature;
 Five Packaging;
 Four Water_type_nonesome;
 Four Cooling_System_nonesome;
 Five Additional_Water_Cooling_nonesome;
 Four Control_type_and_Nominal_Power;
 Six Supply_voltage_and_frequency;

rule

  (Cooling == 0) >> ((Water_type_nonesome != 0) && (Cooling_System_nonesome != 0) && (Additional_Water_Cooling_nonesome == 0) );


(Cooling == 1) >> ((Water_type_nonesome == 0) && (Cooling_System_nonesome == 0) && (Additional_Water_Cooling_nonesome != 0) );
(Control_type_and_Nominal_Power == 0)>>((Control_type == 1) && (Nominal_power == 0));
(Control_type_and_Nominal_Power == 1)>>((Control_type == 1) && (Nominal_power == 1));
(Control_type_and_Nominal_Power == 2)>>((Control_type == 1) && (Nominal_power == 2));
(Control_type_and_Nominal_Power == 3)>>((Control_type == 2) && (Nominal_power == 0));

(Supply_voltage_and_frequency == 0)>>(( Supply_voltage == 1) && ( Supply_frequency == 0)); 
(Supply_voltage_and_frequency == 1)>>(( Supply_voltage == 0) && ( Supply_frequency == 0)); 
(Supply_voltage_and_frequency == 2)>>(( Supply_voltage == 0) && ( Supply_frequency == 1)); 
(Supply_voltage_and_frequency == 3)>>(( Supply_voltage == 1) && ( Supply_frequency == 1)); 
(Supply_voltage_and_frequency == 4)>>(( Supply_voltage == 2) && ( Supply_frequency == 1)); 
(Supply_voltage_and_frequency == 5)>>(( Supply_voltage == 3) && ( Supply_frequency == 1)); 

(Integrated_refridgeration_air_dryer == 1) >> (( Water_draining_system == 0) || (Water_draining_system == 1));
(Oil_water_separator == 1) >> (Water_draining_system == 1);

(Control_type_and_Nominal_Power == 1) >> ((Cooling == 0) && (Additional_Water_Cooling_nonesome == 1));


(
   ((Maximum_capacity == 2  ) && (Nominal_power == 0 ) && (Pressure == 4 ) && (Supply_frequency == 0 ) && (Control_type == 0 ))
|| ((Maximum_capacity == 11 ) && (Nominal_power == 0 ) && (Pressure == 3 ) && (Supply_frequency == 0 ) && (Control_type == 0 ))
|| ((Maximum_capacity == 16 ) && (Nominal_power == 0 ) && (Pressure == 2 ) && (Supply_frequency == 0 ) && (Control_type == 0 ))
|| ((Maximum_capacity == 26 ) && (Nominal_power == 0 ) && (Pressure == 1 ) && (Supply_frequency == 0 ) && (Control_type == 0 ))
|| ((Maximum_capacity == 27 ) && (Nominal_power == 0 ) && (Pressure == 0 ) && (Supply_frequency == 0 ) && (Control_type == 0 ))
|| ((Maximum_capacity == 5  ) && (Nominal_power == 0 ) && (Pressure == 4 ) && (Supply_frequency == 0 ) && (Control_type == 1 ))
|| ((Maximum_capacity == 10 ) && (Nominal_power == 0 ) && (Pressure == 3 ) && (Supply_frequency == 0 ) && (Control_type == 1 ))
|| ((Maximum_capacity == 15 ) && (Nominal_power == 0 ) && (Pressure == 2 ) && (Supply_frequency == 0 ) && (Control_type == 1 ))
|| ((Maximum_capacity == 24 ) && (Nominal_power == 0 ) && (Pressure == 1 ) && (Supply_frequency == 0 ) && (Control_type == 1 ))
|| ((Maximum_capacity == 10 ) && (Nominal_power == 0 ) && (Pressure == 0 ) && (Supply_frequency == 0 ) && (Control_type == 1 ))
|| ((Maximum_capacity == 18 ) && (Nominal_power == 1 ) && (Pressure == 4 ) && (Supply_frequency == 0 ) ) 
|| ((Maximum_capacity == 30 ) && (Nominal_power == 1 ) && (Pressure == 3 ) && (Supply_frequency == 0 ) ) 
|| ((Maximum_capacity == 34 ) && (Nominal_power == 1 ) && (Pressure == 2 ) && (Supply_frequency == 0 ) ) 
|| ((Maximum_capacity == 38 ) && (Nominal_power == 1 ) && (Pressure == 1 ) && (Supply_frequency == 0 ) ) 
|| ((Maximum_capacity == 34 ) && (Nominal_power == 1 ) && (Pressure == 0 ) && (Supply_frequency == 0 ) ) 
|| ((Maximum_capacity == 30 ) && (Nominal_power == 2 ) && (Pressure == 4 ) && (Supply_frequency == 0 ) ) 
|| ((Maximum_capacity == 39 ) && (Nominal_power == 2 ) && (Pressure == 3 ) && (Supply_frequency == 0 ) ) 
|| ((Maximum_capacity == 41 ) && (Nominal_power == 2 ) && (Pressure == 2 ) && (Supply_frequency == 0 ) ) 
|| ((Maximum_capacity == 48 ) && (Nominal_power == 2 ) && (Pressure == 1 ) && (Supply_frequency == 0 ) ) 
|| ((Maximum_capacity == 46 ) && (Nominal_power == 2 ) && (Pressure == 0 ) && (Supply_frequency == 0 ) ) 
|| ((Maximum_capacity == 0  ) && (Nominal_power == 0 ) && (Pressure == 4 ) && (Supply_frequency == 1 ) && ((Supply_voltage  == 0 ) || (Supply_voltage  == 1 ) ) && (Control_type == 0 ))
|| ((Maximum_capacity == 6  ) && (Nominal_power == 0 ) && (Pressure == 3 ) && (Supply_frequency == 1 ) && ((Supply_voltage  == 0 ) || (Supply_voltage  == 1 ) ) && (Control_type == 0 ))
|| ((Maximum_capacity == 13 ) && (Nominal_power == 0 ) && (Pressure == 2 ) && (Supply_frequency == 1 ) && ((Supply_voltage  == 0 ) || (Supply_voltage  == 1 ) ) && (Control_type == 0 ))
|| ((Maximum_capacity == 17 ) && (Nominal_power == 0 ) && (Pressure == 1 ) && (Supply_frequency == 1 ) && ((Supply_voltage  == 0 ) || (Supply_voltage  == 1 ) ) && (Control_type == 0 ))
|| ((Maximum_capacity == 19 ) && (Nominal_power == 0 ) && (Pressure == 0 ) && (Supply_frequency == 1 ) && ((Supply_voltage  == 0 ) || (Supply_voltage  == 1 ) ) && (Control_type == 0 ))
|| ((Maximum_capacity == 1  ) && (Nominal_power == 0 ) && (Pressure == 4 ) && (Supply_frequency == 1 ) && ((Supply_voltage  == 0 ) || (Supply_voltage  == 1 ) ) && (Control_type == 1 ))
|| ((Maximum_capacity == 7  ) && (Nominal_power == 0 ) && (Pressure == 3 ) && (Supply_frequency == 1 ) && ((Supply_voltage  == 0 ) || (Supply_voltage  == 1 ) ) && (Control_type == 1 ))
|| ((Maximum_capacity == 8  ) && (Nominal_power == 0 ) && (Pressure == 2 ) && (Supply_frequency == 1 ) && ((Supply_voltage  == 0 ) || (Supply_voltage  == 1 ) ) && (Control_type == 1 ))
|| ((Maximum_capacity == 12 ) && (Nominal_power == 0 ) && (Pressure == 1 ) && (Supply_frequency == 1 ) && ((Supply_voltage  == 0 ) || (Supply_voltage  == 1 ) ) && (Control_type == 1 ))
|| ((Maximum_capacity == 10 ) && (Nominal_power == 0 ) && (Pressure == 0 ) && (Supply_frequency == 1 ) && ((Supply_voltage  == 0 ) || (Supply_voltage  == 1 ) ) && (Control_type == 1 ))
|| ((Maximum_capacity == 14 ) && (Nominal_power == 1 ) && (Pressure == 4 ) && (Supply_frequency == 1 ) && ((Supply_voltage  == 0 ) || (Supply_voltage  == 1 ) ) )
|| ((Maximum_capacity == 30 ) && (Nominal_power == 1 ) && (Pressure == 3 ) && (Supply_frequency == 1 ) && ((Supply_voltage  == 0 ) || (Supply_voltage  == 1 ) ) )
|| ((Maximum_capacity == 32 ) && (Nominal_power == 1 ) && (Pressure == 2 ) && (Supply_frequency == 1 ) && ((Supply_voltage  == 0 ) || (Supply_voltage  == 1 ) ) )
|| ((Maximum_capacity == 35 ) && (Nominal_power == 1 ) && (Pressure == 1 ) && (Supply_frequency == 1 ) && ((Supply_voltage  == 0 ) || (Supply_voltage  == 1 ) ) )
|| ((Maximum_capacity == 34 ) && (Nominal_power == 1 ) && (Pressure == 0 ) && (Supply_frequency == 1 ) && ((Supply_voltage  == 0 ) || (Supply_voltage  == 1 ) ) )
|| ((Maximum_capacity == 20 ) && (Nominal_power == 2 ) && (Pressure == 4 ) && (Supply_frequency == 1 ) && ((Supply_voltage  == 0 ) || (Supply_voltage  == 1 ) ) )
|| ((Maximum_capacity == 35 ) && (Nominal_power == 2 ) && (Pressure == 3 ) && (Supply_frequency == 1 ) && ((Supply_voltage  == 0 ) || (Supply_voltage  == 1 ) ) )
|| ((Maximum_capacity == 40 ) && (Nominal_power == 2 ) && (Pressure == 2 ) && (Supply_frequency == 1 ) && ((Supply_voltage  == 0 ) || (Supply_voltage  == 1 ) ) )
|| ((Maximum_capacity == 44 ) && (Nominal_power == 2 ) && (Pressure == 1 ) && (Supply_frequency == 1 ) && ((Supply_voltage  == 0 ) || (Supply_voltage  == 1 ) ) )
|| ((Maximum_capacity == 46 ) && (Nominal_power == 2 ) && (Pressure == 0 ) && (Supply_frequency == 1 ) && ((Supply_voltage  == 0 ) || (Supply_voltage  == 1 ) ) )
|| ((Maximum_capacity == 3  ) && (Nominal_power == 0 ) && (Pressure == 4 ) && (Supply_frequency == 1 ) && ((Supply_voltage  == 2 ) || (Supply_voltage  == 3 ) ) && (Control_type == 0 ))
|| ((Maximum_capacity == 13 ) && (Nominal_power == 0 ) && (Pressure == 3 ) && (Supply_frequency == 1 ) && ((Supply_voltage  == 2 ) || (Supply_voltage  == 3 ) ) && (Control_type == 0 ))
|| ((Maximum_capacity == 21 ) && (Nominal_power == 0 ) && (Pressure == 2 ) && (Supply_frequency == 1 ) && ((Supply_voltage  == 2 ) || (Supply_voltage  == 3 ) ) && (Control_type == 0 ))
|| ((Maximum_capacity == 28 ) && (Nominal_power == 0 ) && (Pressure == 1 ) && (Supply_frequency == 1 ) && ((Supply_voltage  == 2 ) || (Supply_voltage  == 3 ) ) && (Control_type == 0 ))
|| ((Maximum_capacity == 29 ) && (Nominal_power == 0 ) && (Pressure == 0 ) && (Supply_frequency == 1 ) && ((Supply_voltage  == 2 ) || (Supply_voltage  == 3 ) ) && (Control_type == 0 ))
|| ((Maximum_capacity == 4  ) && (Nominal_power == 0 ) && (Pressure == 4 ) && (Supply_frequency == 1 ) && ((Supply_voltage  == 2 ) || (Supply_voltage  == 3 ) ) && (Control_type == 1 ))
|| ((Maximum_capacity == 9  ) && (Nominal_power == 0 ) && (Pressure == 3 ) && (Supply_frequency == 1 ) && ((Supply_voltage  == 2 ) || (Supply_voltage  == 3 ) ) && (Control_type == 1 ))
|| ((Maximum_capacity == 18 ) && (Nominal_power == 0 ) && (Pressure == 2 ) && (Supply_frequency == 1 ) && ((Supply_voltage  == 2 ) || (Supply_voltage  == 3 ) ) && (Control_type == 1 ))
|| ((Maximum_capacity == 22 ) && (Nominal_power == 0 ) && (Pressure == 1 ) && (Supply_frequency == 1 ) && ((Supply_voltage  == 2 ) || (Supply_voltage  == 3 ) ) && (Control_type == 1 ))
|| ((Maximum_capacity == 23 ) && (Nominal_power == 0 ) && (Pressure == 0 ) && (Supply_frequency == 1 ) && ((Supply_voltage  == 2 ) || (Supply_voltage  == 3 ) ) && (Control_type == 1 ))
|| ((Maximum_capacity == 23 ) && (Nominal_power == 1 ) && (Pressure == 4 ) && (Supply_frequency == 1 ) && ((Supply_voltage  == 2 ) || (Supply_voltage  == 3 )  ))
|| ((Maximum_capacity == 33 ) && (Nominal_power == 1 ) && (Pressure == 3 ) && (Supply_frequency == 1 ) && ((Supply_voltage  == 2 ) || (Supply_voltage  == 3 )  ))
|| ((Maximum_capacity == 37 ) && (Nominal_power == 1 ) && (Pressure == 2 ) && (Supply_frequency == 1 ) && ((Supply_voltage  == 2 ) || (Supply_voltage  == 3 )  ))
|| ((Maximum_capacity == 42 ) && (Nominal_power == 1 ) && (Pressure == 1 ) && (Supply_frequency == 1 ) && ((Supply_voltage  == 2 ) || (Supply_voltage  == 3 )  ))
|| ((Maximum_capacity == 43 ) && (Nominal_power == 1 ) && (Pressure == 0 ) && (Supply_frequency == 1 ) && ((Supply_voltage  == 2 ) || (Supply_voltage  == 3 )  ))
|| ((Maximum_capacity == 36 ) && (Nominal_power == 2 ) && (Pressure == 4 ) && (Supply_frequency == 1 ) && ((Supply_voltage  == 2 ) || (Supply_voltage  == 3 )  ))
|| ((Maximum_capacity == 45 ) && (Nominal_power == 2 ) && (Pressure == 3 ) && (Supply_frequency == 1 ) && ((Supply_voltage  == 2 ) || (Supply_voltage  == 3 )  ))
|| ((Maximum_capacity == 47 ) && (Nominal_power == 2 ) && (Pressure == 2 ) && (Supply_frequency == 1 ) && ((Supply_voltage  == 2 ) || (Supply_voltage  == 3 ) ))
|| ((Maximum_capacity == 49 ) && (Nominal_power == 2 ) && (Pressure == 1 ) && (Supply_frequency == 1 ) && ((Supply_voltage  == 2 ) || (Supply_voltage  == 3 ) ))
|| ((Maximum_capacity == 50 ) && (Nominal_power == 2 ) && (Pressure == 0 ) && (Supply_frequency == 1 ) && ((Supply_voltage  == 2 ) || (Supply_voltage  == 3 ) ) ));